gtkmm: Gtk::DropControllerMotion Class Reference

gtkmm 4.23.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::DropControllerMotion Class Reference
Event Controllers and Gestures

Event controller for motion events during a drop. More...

`#include <gtkmm/dropcontrollermotion.h>`

Inheritance diagram for Gtk::DropControllerMotion:
[legend]

## Public Member Functions
| DropControllerMotion (DropControllerMotion && src) noexcept
DropControllerMotion & | operator= (DropControllerMotion && src) noexcept
| ~DropControllerMotion () noexcept override
GtkDropControllerMotion * | gobj ()
| Provides access to the underlying C GObject.
const GtkDropControllerMotion * | gobj () const
| Provides access to the underlying C GObject.
GtkDropControllerMotion * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | contains_pointer () const
| Returns if a Drag-and-Drop operation is within the widget self or one of its children.
bool | is_pointer () const
| Returns if a Drag-and-Drop operation is within the widget self, not one of its children.
Glib::RefPtr< Gdk::Drop > | get_drop ()
| Returns the Gdk::Drop of a current Drag-and-Drop operation over the widget of self.
Glib::RefPtr< const Gdk::Drop > | get_drop () const
| Returns the Gdk::Drop of a current Drag-and-Drop operation over the widget of self.
Glib::SignalProxy< void(double, double)> | signal_enter ()
Glib::SignalProxy< void()> | signal_leave ()
Glib::SignalProxy< void(double, double)> | signal_motion ()
Glib::PropertyProxy_ReadOnly< bool > | property_contains_pointer () const
| Whether the pointer of a Drag-and-Drop operation is in the controller's widget or a descendant.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Drop > > | property_drop () const
| The ongoing drop operation over the controller's widget or its descendant.
Glib::PropertyProxy_ReadOnly< bool > | property_is_pointer () const
| Whether the pointer is in the controllers widget itself, as opposed to in a descendent widget.
Public Member Functions inherited from Gtk::EventController
| EventController (EventController && src) noexcept
EventController & | operator= (EventController && src) noexcept
| ~EventController () noexcept override
GtkEventController * | gobj ()
| Provides access to the underlying C GObject.
const GtkEventController * | gobj () const
| Provides access to the underlying C GObject.
GtkEventController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Widget * | get_widget ()
| Returns the Gtk::Widget this controller relates to.
const Widget * | get_widget () const
| Returns the Gtk::Widget this controller relates to.
void | reset ()
| Resets the controller to a clean state.
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events.
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events.
PropagationLimit | get_propagation_limit () const
| Gets the propagation limit of the event controller.
void | set_propagation_limit (PropagationLimit limit)
| Sets the event propagation limit on the event controller.
Glib::ustring | get_name () const
| Gets the name of controller.
void | set_name (const Glib::ustring & name)
| Sets a name on the controller that can be used for debugging.
Glib::RefPtr< const Gdk::Event > | get_current_event () const
| Returns the event that is currently being handled by the controller.
guint32 | get_current_event_time () const
| Returns the timestamp of the event that is currently being handled by the controller.
Glib::RefPtr< Gdk::Device > | get_current_event_device ()
| Returns the device of the event that is currently being handled by the controller.
Glib::RefPtr< const Gdk::Device > | get_current_event_device () const
| Returns the event that is currently being handled by the controller.
Gdk::ModifierType | get_current_event_state () const
| Returns the modifier state of the event that is currently being handled by the controller.
Glib::PropertyProxy_ReadOnly< Widget * > | property_widget () const
| The widget receiving the Gdk::Events that the controller will handle.
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy< PropagationLimit > | property_propagation_limit ()
| The limit for which events this controller will handle.
Glib::PropertyProxy_ReadOnly< PropagationLimit > | property_propagation_limit () const
| The limit for which events this controller will handle.
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name for this controller, typically used for debugging purposes.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name for this controller, typically used for debugging purposes.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< DropControllerMotion > | create ()
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| DropControllerMotion ()
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created.
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::DropControllerMotion > | wrap (GtkDropControllerMotion * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Event controller for motion events during a drop.

Gtk::DropControllerMotion is an event controller meant for tracking the pointer hovering over a widget during a drag and drop operation.

It is modeled after Gtk::EventControllerMotion so if you have used that, this should feel really familiar.

The drop controller is not able to accept drops, use Gtk::DropTarget for that purpose.

Since gtkmm 3.98

See also
  Gdk::Drop, Gtk::DropTarget

## Constructor & Destructor Documentation

## ◆ DropControllerMotion() [1/2]

Gtk::DropControllerMotion::DropControllerMotion | ( | DropControllerMotion && | src | ) |
| noexcept

## ◆ ~DropControllerMotion()

Gtk::DropControllerMotion::~DropControllerMotion | ( |  | ) |
| overridenoexcept

## ◆ DropControllerMotion() [2/2]

Gtk::DropControllerMotion::DropControllerMotion | ( |  | ) |
| protected

## Member Function Documentation

## ◆ contains_pointer()

bool Gtk::DropControllerMotion::contains_pointer | ( |  | ) | const

Returns if a Drag-and-Drop operation is within the widget self or one of its children.

Returns
  true if a dragging pointer is within self or one of its children.

## ◆ create()

Glib::RefPtr< DropControllerMotion > Gtk::DropControllerMotion::create | ( |  | ) |
| static

## ◆ get_drop() [1/2]

Glib::RefPtr< Gdk::Drop > Gtk::DropControllerMotion::get_drop | ( |  | ) |

Returns the Gdk::Drop of a current Drag-and-Drop operation over the widget of self.

Returns
  The Gdk::Drop currently happening within self.

## ◆ get_drop() [2/2]

Glib::RefPtr< const Gdk::Drop > Gtk::DropControllerMotion::get_drop | ( |  | ) | const

Returns the Gdk::Drop of a current Drag-and-Drop operation over the widget of self.

Returns
  The Gdk::Drop currently happening within self.

## ◆ get_type()

GType Gtk::DropControllerMotion::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkDropControllerMotion * Gtk::DropControllerMotion::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkDropControllerMotion * Gtk::DropControllerMotion::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkDropControllerMotion * Gtk::DropControllerMotion::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ is_pointer()

bool Gtk::DropControllerMotion::is_pointer | ( |  | ) | const

Returns if a Drag-and-Drop operation is within the widget self, not one of its children.

Returns
  true if a dragging pointer is within self but not one of its children.

## ◆ operator=()

DropControllerMotion & Gtk::DropControllerMotion::operator= | ( | DropControllerMotion && | src | ) |
| noexcept

## ◆ property_contains_pointer()

Glib::PropertyProxy_ReadOnly< bool > Gtk::DropControllerMotion::property_contains_pointer | ( |  | ) | const

Whether the pointer of a Drag-and-Drop operation is in the controller's widget or a descendant.

See also property_is_pointer().

When handling crossing events, this property is updated before signal_enter(), but after signal_leave() is emitted.

Default value: false

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_drop()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Drop > > Gtk::DropControllerMotion::property_drop | ( |  | ) | const

The ongoing drop operation over the controller's widget or its descendant.

If no drop operation is going on, this property returns nullptr.

The event controller should not modify the drop, but it might want to query its properties.

When handling crossing events, this property is updated before signal_enter(), but after signal_leave() is emitted.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_is_pointer()

Glib::PropertyProxy_ReadOnly< bool > Gtk::DropControllerMotion::property_is_pointer | ( |  | ) | const

Whether the pointer is in the controllers widget itself, as opposed to in a descendent widget.

See also property_contains_pointer().

When handling crossing events, this property is updated before signal_enter(), but after signal_leave() is emitted.

Default value: false

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ signal_enter()

Glib::SignalProxy< void(double, double)> Gtk::DropControllerMotion::signal_enter | ( |  | ) |

Slot Prototype:
  void on_my_enter(double x, double y)

Flags: Run Last

Signals that the pointer has entered the widget.

Parameters

  x | Coordinates of pointer location.
  y | Coordinates of pointer location.

## ◆ signal_leave()

Glib::SignalProxy< void()> Gtk::DropControllerMotion::signal_leave | ( |  | ) |

Slot Prototype:
  void on_my_leave()

Flags: Run Last

Signals that the pointer has left the widget.

## ◆ signal_motion()

Glib::SignalProxy< void(double, double)> Gtk::DropControllerMotion::signal_motion | ( |  | ) |

Slot Prototype:
  void on_my_motion(double x, double y)

Flags: Run First

Emitted when the pointer moves inside the widget.

Parameters

  x | The x coordinate.
  y | The y coordinate.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::DropControllerMotion > wrap | ( | GtkDropControllerMotion * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.